<?php
/*
Plugin Name: Easy Digital Downloads GA Ecommerce Tracking
Description: Track GA e-Commerce data from Easy Digital Downloads
Version: 1.0.0
Author: chicpro
Author URI: https://ncube.net
*/

function ga_ecommerce_tracking_script() {
	
	if( ! class_exists( 'Easy_Digital_Downloads' ) )
		return;
	
	if ( ! edd_is_success_page() )
		return;
	
	global $edd_receipt_args;
	
	$payment = get_post( $edd_receipt_args['id'] );
	$meta = edd_get_payment_meta( $payment->ID );	

	// Get Transaction ID
	if ( isset( $_GET['payment_key'] ) ) {
		$payment_key = trim($_GET['payment_key']);
	} else if ( isset( $edd_receipt_args['id'] ) ) {
		$payment_key = $edd_receipt_args['id'];
	} else if ( isset( $meta['key'] ) ) {
		$payment_key = $meta['key'];
	}

	if ( ! isset( $payment_key ) )
		return;
	
	// Payment Info
	$cart_items = array();
	$payment_obj = new EDD_Payment( $payment->ID );
	$total = $payment_obj->total;
	$tax = $payment_obj->tax;
	
	if( isset( $meta['cart_details'] ) )
		$cart_items = $meta['cart_details'];

	//echo '<div style="display:none;">';
	//print_r($payment_key);
	//echo '</div>';

	if(!empty($cart_items)) {
	?>
	<script>
	gtag('event', 'purchase', {
		"transaction_id": "<?php echo $payment_key; ?>",
		"affiliation": "<?php bloginfo( "name" ); ?>",
		"value": <?php echo esc_js( $total ); ?>,
		"currency": "KRW",
		"tax": <?php echo esc_js( $tax ); ?>,
		"shipping": 0,	
		"items": [
			<?php
			$i = 0;
			foreach( $cart_items as $key => $product ) {
				if($i > 0)
					echo ','.PHP_EOL;
			?>
			{
				"id": "<?php echo esc_js( $product["id"] ); ?>",
				"name": "<?php echo esc_js( $product["name"] ); ?>",
				"quantity": <?php echo esc_js( $product["quantity"] ); ?>,
				"price": '<?php echo esc_js( $product["item_price"] ); ?>'
			}
			<?php
				$i++;
			}
			?>
		]
	});
	</script>	
	<?php
	}
}

add_action( 'wp_footer', 'ga_ecommerce_tracking_script', 20 );